/* Problem URL: https://codeforces.com/edu/course/2/lesson/6/3/practice/contest/285083/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, d;
    cin >> n >> m >> d;

    V<V<pair<int, int>>> graph(n);

    while (m--) {
        int a, b, c;
        cin >> a >> b >> c;

        graph[a - 1].emplace_back(b - 1, c);
    }

    vi parent(n);

    int ans = -1;
    int low = 0;
    int high = 1e9;

    while (low <= high) {
        int mid = ((high - low) >> 1) + low;

        vi p(n);

        auto bfs = [&]() {
            const int inf = INT32_MAX >> 1;

            vi dis(n, inf);
            queue<int> q;

            dis[0] = 0;
            q.push(0);

            while (!q.empty()) {
                int i = q.front();
                q.pop();

                for (auto [j, c] : graph[i]) {
                    if (c > mid) {
                        continue;
                    }

                    if (dis[j] > dis[i] + 1) {
                        dis[j] = dis[i] + 1;
                        p[j] = i;
                        q.push(j);
                    }
                }
            }

            return dis.back();
        };

        int now = bfs();

        if (now <= d) {
            ans = mid;
            parent = move(p);
            high = mid - 1;
            continue;
        }

        low = mid + 1;
    }

    if (ans == -1) {
        cout << "-1\n";
        return 0;
    }

    vi tmp = {n};
    int now = parent[n - 1];
    while (now != 0) {
        tmp.push_back(now + 1);
        now = parent[now];
    }

    tmp.push_back(1);
    reverse(all(tmp));

    cout << tmp.size() - 1 << '\n' << tmp;
}
